// extractor.cc
//
// Mark Johnson, 17th July 2002
//
// Extracts patters for empty node recovery from treebank trees.

#include <cassert>
#include <cstdio>
#include <iostream>
#include <iterator>  // for iterator_traits
#include <vector>
#include <utility>

#include "auxmj.h"
#include "restore-empties.h"
#include "sym.h"
#include "transitive-verbs.h"
#include "tree.h"
#include "utility.h"

int main(int argc, char** argv)
{
  typedef std::vector<tree*> Ts;
  Ts ts;

  readtree_filename = "(stdin)";
  readtree_lineno = 1;

  tree* tp;
  while ((tp = readtree_root(stdin))) {
    ts.push_back(tp);
    tp->delete_unary_same_label_chains();
    auxify(tp);
  }

  TransitiveVerbs tv;
  tv.load_transitive_verbs(ts);
  std::cout << tv << std::endl;        // write out transitive verbs
  tv.label_transitive_verbs(ts);       // label the transitive verbs
  
  restore_empties<stree_lex_pattern<select_none, false, false> > re(ts);

  std::cout << re;
}

