// heads.h
//
// Mark Johnson, 9th November 2001

#ifndef HEADS_H
#define HEADS_H

#include "tree.h"

// tree_syntacticHeadChild() returns a pointer to the
//  child of t that is the syntactic head of t, or NULL
//  if none exists (e.g., if t is a preterminal).
//
const tree* tree_syntacticHeadChild(const tree* t);

// tree_syntacticLexicalHead() returns a pointer to a
//  preterminal node dominated by t that is its lexical
//  syntactic head.  Note that this node may be empty!
//
const tree* tree_syntacticLexicalHead(const tree* t);


// tree_semanticHeadChild() returns a pointer to the
//  child of t that is the semantic head of t, or NULL
//  if none exists (e.g., if t is a preterminal).
//
const tree* tree_semanticHeadChild(const tree* t);

// tree_semanticLexicalHead() returns a pointer to a
//  preterminal node dominated by t that is its lexical
//  semantic head.  Note that this node may be empty!
//
const tree* tree_semanticLexicalHead(const tree* t);

#endif // HEADS_H
